#ifndef __GRADER_H__
#define __GRADER_H__

#ifdef __cplusplus
extern "C" {
#endif

void init(int R, int C);
void update(int P, int Q, long long K);
long long calculate(int P, int Q, int U, int V);

typedef void (*initFunction)(int R, int C);
typedef void (*updateFunction)(int P, int Q, long long K);
typedef long long (*calculateFunction)(int P, int Q, int U, int V);

#ifdef __cplusplus
}
#endif

#endif /* __GRADER_H__ */
