#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "grader.h"

#define SECRET "srhbtvghierhgujwed"

#if ( _WIN32 || __WIN32__ )
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define MAX_SIZE 1000000000
#define MAX_N 272000

int _main(initFunction init, updateFunction update, calculateFunction calculate) {
	int R, C, N;
    int P, Q, U, V;
    long long K;
    int i, type;

	assert(scanf("%d", &R) == 1);
	assert(scanf("%d", &C) == 1);
	assert(scanf("%d", &N) == 1);

    init(R, C);

	for (i = 0; i < N; i++) {
        assert(scanf("%d", &type) == 1);
        if (type == 1) {
		    assert(scanf("%d%d"LLD, &P, &Q, &K) == 3);
            update(P, Q, K);
        } else if (type == 2) {
 		    assert(scanf("%d%d%d%d", &P, &Q, &U, &V) == 4);
            printf("%s "LLD"\n", SECRET, calculate(P, Q, U, V));
        } 
	}

	return 0;
}
